<template>
  <header>
    <section class="header-section left">
      <div class="header-block clickable" style="margin-right: 10px" @click="$router.push({name: 'home'}).catch(err=>{})">
        Green Booking Machine
      </div>
      <div class="divider"/>
      <div class="header-block">
        <CityPicker/>
      </div>
    </section>
    <section class="header-section right">
      <template v-if="logged_in">
        <div @click="navigateUserPage" class="header-block clickable">
          <div class="user-pic-container">
            <img class="user-pic" alt="Ваш аватар" :src="user.gravatar"/>
          </div>
          <div class="username">{{user.username}}</div>
        </div>
        <div class="header-block clickable" @click="logout">Выйти</div>
      </template>
      <template v-else>
        <div><router-link to="/auth/">Вход</router-link></div>
        <div><router-link to="/register/">Регистрация</router-link></div>
      </template>
    </section>
  </header>
</template>

<script>
import CityPicker from './CityPicker'
export default {
  name: 'Header',
  components: { CityPicker },
  props: ['user'],
  data: () => {
    return {
      username: null
    }
  },
  methods: {
    logout() {
      this.$root.$emit('loggedOut');
    },
    navigateUserPage() {
      this.$router.push({name: 'user'})
    }
  },
  computed: {
    logged_in() { return this.user !== null }
  }
}
</script>

<style scoped>
header {
  grid-row: 1;
  display: flex;
  flex-wrap: nowrap;
  flex-direction: row;
  justify-content: flex-start;
  align-items: stretch;
  background-color: black;
  padding-left: 12px;
  padding-right: 12px;
  font-family: 'Oswald', 'Impact', sans-serif;
  font-size: 18pt;
}

.header-section {
  flex-grow: 1;
  display: flex;
}

.divider {
  height: 80%;
  margin: auto 0;
  border-left: 1px solid white;
  width: 0;
}

.header-section.left {
  justify-content: flex-start;
}

.header-section.right {
  justify-content: flex-end;
}

.header-section * {
  display: flex;
  justify-content: center;
  align-items: center;
  padding: 0 3px;
  margin-right: 3px;
  text-align: center;
}

.header-block:hover {
  filter: brightness(110%);
  color: white;
}

.clickable {
  cursor: pointer;
}

.user-pic-container {
  width: 48px;
  height: 48px;
  border-radius: 50%;
  overflow: hidden;
  padding: 0;
  margin: 0 3px 0 0;
}

.user-pic {
  width: 100%;
  height: 100%;
  object-fit: cover;
  margin: 0;
  padding: 0;
}

.username {
  min-width: 80px;
}
</style>
